
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*  This code generated by: 
 *      Author : thomas
 *      Date   : Mon Jun 23 2003
 */

#include <kdebug.h>
#include "javacodedocumentation.h"
#include "javaclassifiercodedocument.h"
#include "javacodegenerationpolicy.h"

// Constructors/Destructors
//  

JavaCodeDocumentation::JavaCodeDocumentation ( JavaClassifierCodeDocument * doc, QString text ) 
    : CodeComment ((CodeDocument*) doc, text)
{

}

JavaCodeDocumentation::JavaCodeDocumentation ( JavaClassifierCodeDocument * doc ) 
    : CodeComment ((CodeDocument*) doc)
{

}

JavaCodeDocumentation::~JavaCodeDocumentation ( ) { }

//  
// Methods
//  


// Accessor methods
//  

// Other methods
//  

/**
 * Save the XMI representation of this object
 * @return      bool    status of save
 */
bool JavaCodeDocumentation::saveToXMI ( QDomDocument & doc, QDomElement & root ) {
        bool status = true;

        QDomElement blockElement = doc.createElement( "javacodedocumentation" );
        setAttributesOnNode(doc, blockElement); // as we added no additional fields to this class we may
                                                // just use parent TextBlock method
        root.appendChild( blockElement );

        return status;
}

/**
 * load params from the appropriate XMI element node.
 */
void JavaCodeDocumentation::loadFromXMI ( QDomElement & root ) {
        setAttributesFromNode(root);
}

/**
 * @return	QString
 */
QString JavaCodeDocumentation::toString ( ) 
{

	QString output = "";

        // simple output method
        if(getWriteOutText())
        {
		bool useDoubleDashOutput = true;

		// need to figure out output type from java policy
		JavaCodeGenerationPolicy * p = ((JavaClassifierCodeDocument*)getParentDocument())->getJavaPolicy();
		if(p->getCommentStyle() == JavaCodeGenerationPolicy::SlashStar)
			useDoubleDashOutput = false;

		QString indent = getIndentationString();
                QString endLine = getNewLineEndingChars();
		QString body = getText();
		if(useDoubleDashOutput) 
		{
			if(!body.isEmpty())
                		output.append(formatMultiLineText (body, indent +"// ", endLine));
		} else {
                	output.append(indent+"/**"+endLine);
			if(!body.isEmpty())
                		output.append(formatMultiLineText (body, indent +" * ", endLine));
                	output.append(indent+" */"+endLine);
		}
        }

        return output; 
}


#include "javacodedocumentation.moc"
